function out = Plotchoice
% filename: Plotchoice.m
% Project: 2-D Array Antenna Pattern
% Description: This program prompts the user for the choice of 
%			pattern plot for a theta or phi-cut. 
% Author:  Prof. David C. Jenn and Elmo E. Garrido Jr.
% Date:   04 September 2000 (Happy Labor Day!) and onwards
% Place: NPS
%
% 	Plotchoice GUI

h0 = figure('Units','normalized', ...
	'Color',[0.8 0.8 0.8], ...
	'MenuBar','none', ...
	'Name','  PATTERN PLOT', ...
	'NumberTitle','off', ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
	'Position',[0.3564 0.3958 0.3369 0.1576], ...
	'Resize','off', ...
	'Tag','Plotchoice', ...
	'ToolBar','none');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'FontName','Arial', ...
	'FontSize',0.6, ...
	'Position',[0.1739 0.7355 0.6203 0.17356], ...
	'String','What kind of pattern plot do you want?', ...
	'Style','text', ...
   'Tag','StaticText1');
% Radiobuttons Rectangular and Polar
e = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'Callback','setrad Rectangular;', ...
	'FontName','Arial', ...
	'FontSize',0.6, ...
	'Position',[0.29856 0.5455 0.2696 0.1736], ...
	'String','Rectangular', ...
   'Style','radiobutton', ...
   'Value',1,...
	'Tag','Rectangular');
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'Callback','setrad Polar;', ...
	'FontName','Arial', ...
	'FontSize',0.6, ...
	'Position',[0.2986 0.3388 0.2203 0.1736], ...
	'String','Polar', ...
	'Style','radiobutton', ...
	'Tag','Polar', ...
	'Value',0);
% Pushbuttons OK and Cancel
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'Callback','uiresume(gcbf);', ...
	'FontName','Arial', ...
	'FontSize',0.5, ...
	'ListboxTop',0, ...
	'Position',[0.4 0.1 0.1942 0.2149], ...
	'String','OK', ...
	'Tag','OK');
uiwait(h0)
out = get(e,'Value');
close(h0);