function C = helpmaintxt
% filename: helpmaintxt.m
% Project: RADJAM
% Description:  This program contains the text displayed in the RADJAM 
%			Main Help GUI.
% Author:  Prof. David C. Jenn 
% Date: July 2002
% Place: NPS
%
 C   =  {'RADAR AND JAMMING SIMULATION';...
			' ';...
			'Brief description of the simulation and quantities:';...
			' ';...
			'The radar antenna main beam is pointed on the target as the';...
			'target moves in azimuth from the start angle to the stop angle.';...
			'The maximum detection range is computed for the specified min';...
			'signal-to-noise ratio (SNRmin).  The jammer location remains';...
			'fixed. Multipath is included if the magnitude of the reflection';...
			'coefficient is not zero.  In this case the detection contour is';...
			'computed over a square grid of size <Grid max range>. The grid';...
			'cell size is <Rng step>.';...
			' ';...
			'RADAR PARAMETERS:'; ...
         'Pt = radar tranmitter power (dBw)'; ...
         'Tau = pulse width (microsec)'; ...
         'Bn = noise bandwidth (MHz) - generally Bn ~ 1/Tau'; ...
         'TA = antenna temperature (K)'; ...
         'Te = receiver effective temperature (K)'; ...      
         'Gp = processing gain (dB)'; ...
  			'hr = height of radar above flat earth (m)'; ...
			'fmhz = frequency (MHz)';...
			'SNRmin = minimum SNR required for detection (dBm)';...
			'The radar location is denoted by R on the plots.';...
			' ';...
		   'gammag = magnitude of ground reflection coefficient';...
			'  (gammag = 0 no multipath; 1 >= gammag > 0 multipath)';...
			'gamfaz = phase of ground reflection coefficient (deg)';...
            'freq = frequency (GHz); wave = wavelength (m)';...
			' ';...
		   'TARGET PARAMETERS:'; ...
         'RCS = target radar cross section (dBsm)'; ...
         'ht = target height (m)'; ...
			'The target location is moved through the azimuth angles';...
			'specified with increment <Az step> when there is no multi-';...
			'path.  When multipath is present the closed form solution';...
			'of the radar range equation cannot be used.  In this case';...
			'the detection contours are searched for inside of a square';...
			'range box of dimension <Grid max range>. The gains for the';...
			'direct and reflected paths are assumed equal.';...
			' ';...
	      'JAMMER PARAMETERS:'; ...
         'hj = height of jammer above flat earth (m)'; ...
         'Rj = jammer range (km)'; ...
         'Azj = jammer azimuth (deg) usually set to 0 - changing Azj only'; ... 
         '       rotates the detection contours in azimuth angle';...
         'Bj = jammer bandwidth (MHz)'; ...
			'Gj = jammer power (dBw)';...
			'The jammer location is denoted by J on the plots. The gains';...  
			'for the direct and reflected paths are assumed equal.';...
			' ';...
			'ANTENNA PARAMETERS:';...
			'Note that the radar antenna max gain is on the target.';...
			'ha = antenna height (m)';...
			'Wa = antenna azimuth aperture dimension in meters';...
			'We = antenna elevation aperture dimension in meters';...
			'eta = antenna efficiency (exclusive of aperture efficiency';...
			'       which is included in the gain calculation)';...
			'SLL = sidelobe level (dB) - should be <= -15 or else uniform used';...
			'BLL = backlobe level (dB) - should be <= SLL';...
			' ';...
			'Antenna model: SLL and BLL apply to the azimuth plane; uniform';...
			'distribution is assumed in the elevation plane.  The azimuth';...
			'pattern is generated with a Taylor distribution. A cosine^2 on a';...
			'pedestal factor is applied so that the pedestal height is equal';...
			'to BLL. The backlobe suppression factor is not included in the';...
            'efficiency calculation.';...
            ' ';...
            'The antenna pattern will be plotted when <yes> is selected in the';...
            'pull-down menu and gammag=0.';... 
			' ';...
			'Note that the assumptions of direct and reflected path gains';...
			'being the same imply that the differences in heights of the';...
			'radar, jammer and target should not be too great.';
			' ';...
			'There is no polarization loss considered.  The gains, radar';...
			'cross section, and reflection coefficient should be defined for';...
			'the same polarization.';...
         ' ';...
         'Note that the jammer power is in W but the radar power is in dBw.';...
			'The minimum SNR is in dBm.';...
         ' ';...
         'If your computer is having problems displaying the GUI (only the';...
			'header bar is visible), then it may be necessary to run Matlab';...
			'in the 256 color mode.';...
			' ';...
			'DISCLAIMER: This code was created for instructional purposes.';...
			'Basic test geometries have been validated, however, there is';...
			'no guarantee of accuracy in all cases.';...
	      '  ';};