function fig = msgComputing(command_str)
% filename: msgComputing.m
% Project: RADJAM
% Description: This function displays a message that the jamming contour
%			is being computed.
% Author:  Prof. David C. Jenn
% Date:  09 June 2002
% Place: NPS
%
% 	MSGCOMPUTING GUI

if nargin == 0
   command_str = 'initialize';
end

% Initialize the GUI
if strcmp(command_str,'initialize')
   h_figs = get(0,'children');
   fig_exists = 0;
   for fig = h_figs'
      fig_exists = strcmp(get(fig,'Tag'),'MsgComputing');
      if fig_exists
         figure(fig);
         return;
      end
   end
end

% FIGURE 2 is the message
h0 = figure('Units','normalized', ...
	'BackingStore','off', ...
	'Color',[0.8 0.8 0.8], ...
	'MenuBar','none', ...
	'Name','  Computing ... ', ...
	'NumberTitle','off', ...
	'PaperPosition',[158.25 359.25 295.5 73.5], ...
	'Position',[0.30 0.44 0.30 0.12], ...
	'Resize','off', ...
	'Tag','MsgComputing', ...
   'ToolBar','none');
% text
h1 = uicontrol('Parent',h0, ...
	'Units','normalized', ...
   'FontU','normalized', ...  
  	'Backg',[0.8 0.8 0.8], ...
	'FontS',0.4, ...
  	'FontN','Arial', ...
	'Horiz','left', ...
	'Position',[0.1 0.4 0.85 0.3], ...
   'String',command_str, ...
	'Style','text', ...
   'Tag','StaticText3');
