function setrad(action)
% filename: setrad.m   (qloss and dif. beam fixed)
% Project: radar and jamming simulation
% Description: This program implements the functionalities of the 
% Author:  Prof. David C. Jenn
% Date:   June 2002
% Place: NPS

switch(action)
   
   case 'AStart'
      h_start = findobj(gcf,'Tag','AStart'); 
      start_str = get(h_start,'String');
      Astart=str2num(start_str);
      set(h_start,'String',num2str(Astart));

   case 'AStop'
      h_stop = findobj(gcf,'Tag','AStop'); 
      stop_str = get(h_stop,'String'); 
      Astop=str2num(stop_str);
      set(h_stop,'String',num2str(Astop));

   case 'AStep'
      h_step = findobj(gcf,'Tag','AStep');
      step_str = get(h_step,'String'); 
      Astep=str2num(step_str);
      set(h_step,'String',num2str(Astep));     

   case 'SNRMIN'
      h_SNRval = findobj(gcf,'Tag','SNRMIN'); 
      SNR_str = get(h_SNRval,'String');
      SNRdbm=str2num(SNR_str);
      set(h_SNRval,'String',num2str(SNRdbm));
      
   case 'Ptx'
      h_ptx = findobj(gcf,'Tag','Ptx'); 
      ptx_str = get(h_ptx,'String'); 
      Ptdb=str2num(ptx_str);
      set(h_ptx,'String',num2str(Ptdb));

   case 'Tau'
      h_Tau = findobj(gcf,'Tag','Tau');
      Tau_str = get(h_Tau,'String'); 
      Tauus=str2num(Tau_str);
      set(h_Tau,'String',num2str(Tauus));     

   case 'Gproc'
      h_gp = findobj(gcf,'Tag','Gproc'); 
      gp_str = get(h_gp,'String');
      Gpdb=str2num(gp_str);
      set(h_gp,'String',num2str(Gpdb));
      
   case 'TAnt'
      h_TA = findobj(gcf,'Tag','TAnt'); 
      TA_str = get(h_TA,'String'); 
      TA = str2num(TA_str); 
      set(h_TA,'String',num2str(TA));

   case 'Teff'
      h_Te = findobj(gcf,'Tag','Teff'); 
      Te_str = get(h_Te,'String'); 
      Te = str2num(Te_str); 
      set(h_Te,'String',num2str(Te));
      
   case 'BWR'
      h_B = findobj(gcf,'Tag','BWR'); 
      B_str = get(h_B,'String'); 
      Bmhz = str2num(B_str); 
      set(h_B,'String',num2str(Bmhz));
              
   case 'Jampow'
      h_pj = findobj(gcf,'Tag','Jampow'); 
      pj_str = get(h_pj,'String'); 
      Pj = str2num(pj_str); 
      set(h_pj,'String',num2str(Pj));
      
   case 'Jamgain'
      h_gj = findobj(gcf,'Tag','Jamgain'); 
      gj_str = get(h_gj,'String'); 
      Gjdb = str2num(gj_str); 
      set(h_gj,'String',num2str(Gjdb));
      
   case 'Jamnoise'
      h_bj = findobj(gcf,'Tag','Jamnoise'); 
      bj_str = get(h_bj,'String'); 
      Bjmhz = str2num(bj_str); 
      set(h_bj,'String',num2str(Bjmhz));

   case 'RCSdb'
      h_rcs = findobj(gcf,'Tag','RCSdb'); 
      rcs_str = get(h_rcs,'String'); 
      RCSdb = str2num(rcs_str); 
      set(h_rcs,'String',num2str(RCSdb));

   case 'Welev'
      h_we = findobj(gcf,'Tag','Welev'); 
      we_str = get(h_we,'String'); 
      We = str2num(we_str); 
      set(h_we,'String',num2str(We));
      
   case 'Wazim'
      h_wa = findobj(gcf,'Tag','Wazim'); 
      wa_str = get(h_wa,'String'); 
      Waz = str2num(wa_str); 
      set(h_wa,'String',num2str(Waz));
 
   case 'Anteff'
      h_ae = findobj(gcf,'Tag','Anteff'); 
      ae_str = get(h_ae,'String'); 
      er = str2num(ae_str); 
      h_mag = findobj(gcf,'Tag','Gmag'); 
      mag_str = get(h_mag,'String'); 
      gammag = str2num(mag_str); 
     if er > 1 | gammag < 0
       errordlg('Antenna efficiency must be between 0 and 1.','error');
       set(h_ae,'String',num2str(1));
      else       
       set(h_ae,'String',num2str(er));
      end


   case 'Freq'
      h_fr = findobj(gcf,'Tag','Freq'); 
      fr_str = get(h_fr,'String'); 
      Fghz = str2num(fr_str); 
      set(h_fr,'String',num2str(Fghz));
      
   case 'MaxRng'
      h_rng = findobj(gcf,'Tag','MaxRng'); 
      rng_str = get(h_rng,'String'); 
      Rmaxkm = str2num(rng_str); 
      set(h_rng,'String',num2str(Rmaxkm));
      
   case 'radhgt'
      h_rht = findobj(gcf,'Tag','radhgt'); 
      rht_str = get(h_rht,'String'); 
      ht = str2num(rht_str); 
      set(h_rht,'String',num2str(ht));
      h_mag = findobj(gcf,'Tag','Gmag'); 
      mag_str = get(h_mag,'String'); 
      gammag = str2num(mag_str);
      if ht==0 & gammag~=0
        errordlg('All heights should be > 0 for multipath to occur.','error');
      end
 
   case 'Jamhgt'
      h_jam = findobj(gcf,'Tag','Jamhgt'); 
      jam_str = get(h_jam,'String'); 
      hj = str2num(jam_str); 
      set(h_jam,'String',num2str(hj));
      h_mag = findobj(gcf,'Tag','Gmag'); 
      mag_str = get(h_mag,'String'); 
      gammag = str2num(mag_str);
      if hj==0 & gammag~=0
        errordlg('All heights should be > 0 for multipath to occur.','error');
      end   
      
    case 'Jamaz'
      h_jaz = findobj(gcf,'Tag','Jamaz'); 
      jaz_str = get(h_jaz,'String'); 
      Azjdeg = str2num(jaz_str); 
      set(h_jaz,'String',num2str(Azjdeg));
      
    case 'Slldb'
      h_sll = findobj(gcf,'Tag','Slldb'); 
      sll_str = get(h_sll,'String'); 
      SLLdb = str2num(sll_str);
      if SLLdb > 0
       errordlg('SLLdb must be negative.','error');
       set(h_sll,'String',num2str(-15));
      end
      if SLLdb >-15 & SLLdb < 0
       errordlg('Using uniform distribution for SLLdb > -15 dB.','warning');
       set(h_sll,'String',num2str(SLLdb))
      end
      if SLLdb <= -15
       set(h_sll,'String',num2str(SLLdb));
      end
   
    case 'Blldb'
      h_bll = findobj(gcf,'Tag','Blldb'); 
      bll_str = get(h_bll,'String'); 
      BLLdb = str2num(bll_str);
      h_sll = findobj(gcf,'Tag','Slldb'); 
      sll_str = get(h_sll,'String'); 
      SLLdb = str2num(sll_str);
      if BLLdb > 0 | BLLdb > SLLdb
       errordlg('BLLdb must be negative and less than SLL.','warning');
       set(h_bll,'String',num2str(-20));
      else
       set(h_bll,'String',num2str(BLLdb));
      end
      
   case 'Gmag'
      h_mag = findobj(gcf,'Tag','Gmag'); 
      mag_str = get(h_mag,'String'); 
      gammag = str2num(mag_str); 
      set(h_mag,'String',num2str(gammag));
     if gammag > 1 | gammag < 0
       errordlg('Reflection coefficient magnitude must be between 0 and 1.','warning');
       set(h_mag,'String',num2str(0));
      else       
       set(h_mag,'String',num2str(gammag));
      end
% if mulitpath is to occur all heights must be > 0     
      h_jam = findobj(gcf,'Tag','Jamhgt'); 
      jam_str = get(h_jam,'String'); 
      hj = str2num(jam_str); 
      h_tht = findobj(gcf,'Tag','tgthgt'); 
      tht_str = get(h_tht,'String'); 
      ht = str2num(tht_str); 
      h_rht = findobj(gcf,'Tag','radhgt'); 
      rht_str = get(h_rht,'String'); 
      hr = str2num(rht_str);
     if gammag~0 & (ht==0 | hr==0 | hj==0)
       errordlg('All heights should be > 0 for multipath to occur.','warning');
     end       
   case 'Gfaz'
      h_ang = findobj(gcf,'Tag','Gfaz'); 
      ang_str = get(h_ang,'String'); 
      gamang = str2num(ang_str); 
      set(h_ang,'String',num2str(gamang));
      
   case 'Jamrng'
      h_grng = findobj(gcf,'Tag','Jamrng'); 
      grng_str = get(h_grng,'String'); 
      Rjkm = str2num(grng_str); 
      set(h_grng,'String',num2str(Rjkm));

   case 'tgthgt'
      h_tht = findobj(gcf,'Tag','tgthgt'); 
      tht_str = get(h_tht,'String'); 
      ht = str2num(tht_str); 
      set(h_tht,'String',num2str(ht));
      h_mag = findobj(gcf,'Tag','Gmag'); 
      mag_str = get(h_mag,'String'); 
      gammag = str2num(mag_str);
      if ht==0 & gammag~=0 
        errordlg('All heights should be > 0 for multipath to occur.','warning');
      end
      
   case 'Rectangular'
      if get(findobj(gcf,'Tag','Rectangular'),'Value') == 1
         set(findobj(gcf,'Tag','Polar'),'Value',0);
      elseif get(findobj(gcf,'Tag','Rectangular'),'Value') == 0
         set(findobj(gcf,'Tag','Polar'),'Value',1);        
      end
      
   case 'Polar'
      if get(findobj(gcf,'Tag','Polar'),'Value') == 1
         set(findobj(gcf,'Tag','Rectangular'),'Value',0);
      elseif get(findobj(gcf,'Tag','Polar'),'Value') == 0
         set(findobj(gcf,'Tag','Rectangular'),'Value',1);   
      end

   case 'Calculate'
   
% get final edit box values
 rad=pi/180;  
 Astart = str2num(get(findobj(gcf,'Tag','AStart'),'String')); 
 Astop  = str2num(get(findobj(gcf,'Tag','AStop'),'String')); 
 Astep  = str2num(get(findobj(gcf,'Tag','AStep'),'String')); 
 Rmaxkm = str2num(get(findobj(gcf,'Tag','MaxRng'),'String')); 
 hj = str2num(get(findobj(gcf,'Tag','Jamhgt'),'String')); 
 Pj = str2num(get(findobj(gcf,'Tag','Jampow'),'String'));
 Gjdb = str2num(get(findobj(gcf,'Tag','Jamgain'),'String')); 
 Bjmhz  = str2num(get(findobj(gcf,'Tag','Jamnoise'),'String')); 
 Rjkm  = str2num(get(findobj(gcf,'Tag','Jamrng'),'String')); 
 Azjdeg = str2num(get(findobj(gcf,'Tag','Jamaz'),'String')); 
 gammag = str2num(get(findobj(gcf,'Tag','Gmag'),'String')); 
 gamang = str2num(get(findobj(gcf,'Tag','Gfaz'),'String'));
 rcsdbm = str2num(get(findobj(gcf,'Tag','RCSdb'),'String')); 
 SLLdb  = str2num(get(findobj(gcf,'Tag','Slldb'),'String'));
 BLLdb  = str2num(get(findobj(gcf,'Tag','Blldb'),'String')); 
 er = str2num(get(findobj(gcf,'Tag','Anteff'),'String')); 
 Wa = str2num(get(findobj(gcf,'Tag','Wazim'),'String')); 
 We = str2num(get(findobj(gcf,'Tag','Welev'),'String')); 
 hr = str2num(get(findobj(gcf,'Tag','radhgt'),'String'));
 ht = str2num(get(findobj(gcf,'Tag','tgthgt'),'String'));
 fmhz = str2num(get(findobj(gcf,'Tag','Freq'),'String')); 
 Te = str2num(get(findobj(gcf,'Tag','Teff'),'String')); 
 TA = str2num(get(findobj(gcf,'Tag','TAnt'),'String')); 
 tauus = str2num(get(findobj(gcf,'Tag','Tau'),'String')); 
 Bmhz = str2num(get(findobj(gcf,'Tag','BWR'),'String')); 
 Gpdb = str2num(get(findobj(gcf,'Tag','Gproc'),'String'));
 Ptdb = str2num(get(findobj(gcf,'Tag','Ptx'),'String')); 
 SNRdbm = str2num(get(findobj(gcf,'Tag','SNRMIN'),'String'));
 Fghz = str2num(get(findobj(gcf,'Tag','Freq'),'String'));
 % =1 yes plot pattern; =2 no pattern plot
 iantplot = get(findobj(gcf,'Tag','antpat'),'Value');
 % some final error checking
  if gammag > 1 | gammag < 0, Reflectionerror; end
  if gammag~=0 
      if ht==0 | hr==0 | hj==0, Heighterror; end
  end

Ts=TA+Te;        % radar system noise temperature
freq=Fghz*1e9;   % frequency
c=3e8;           % velocity of light
wave=c/freq;     % wavelength
k=2*pi/wave;
G0=antradpat(wave,Wa,We,SLLdb,BLLdb,0,0);   % max gain of radar antenna is on target
disp(['Max antenna gain (including aper. effic.), dB: ',num2str(10*log10(G0))]);
Gp=10^(Gpdb/10);
tau=tauus*1e-6;  % radar pulse width
Bn=Bmhz*1e6;     % radar noise bandwidth
boltz=1.38e-23;  % Boltzman's constant
No=boltz*Ts*Bn;  % noise power
SNRmindb=SNRdbm-30;
SNRmin=10^(SNRmindb/10);
Smin=SNRmin*No;  % minimum detectable signal (MDS) in db
Pt=10^(Ptdb/10);

gam=gammag*exp(j*gamang*rad);

% TARGET PARAMETERS **************************************************************
rcs=10^(rcsdbm/10);
% max detection range with no jamming
RRmax=((Pt*G0^2*rcs*wave^2*Gp)/(4*pi)^3/SNRmin/No)^(1/4);
disp(['Max detection range without jamming = ',num2str(RRmax/1e3),' km'])

% JAMMER PARAMETERS **************************************************************
Gj=10^(Gjdb/10);
Bj=Bjmhz*1e6;           % jammer bandwidth
Rj=Rjkm*1e3;      % jammer range fixed
angj=Azjdeg*rad;     % jammer angle fixed
xj=Rj*cos(angj); yj=Rj*sin(angj);

% compute antenna pattern if requested
if iantplot==1 & gammag == 0
    T=[Astart:Astep:Astop];
    Nit=floor((Astop-Astart)/Astep)+1;
     for i=1:Nit
       thd=T(i);
       F(i)=antradpat(wave,Wa,We,SLLdb,BLLdb,(thd-Azjdeg*0)*rad,90*rad);
     end
     Fdb=10*log10(abs(F)+1e-5);
    answer = Plotchoice;
   if answer == 1,
    figure(2),clf
    plot(T,Fdb),grid
    Gref=floor(max(Fdb)/5+1)*5;   % max gain value for plot, 5 dB grid steps
    dyn=60;  % at least 60 dB dynamic range for plot
    dyn=max([60,Gref-BLLdb+5]);
    axis([Astart,Astop,Gref-dyn,Gref])
    xlabel('Azimuth Angle, deg')
    ylabel('Normalized Power, dB')
    title(['Azimuth antenna pattern: SLL =',num2str(SLLdb),...
          ' dB, BLL = ',num2str(BLLdb),'dB'])
   end
   if answer == 0
    figure(2),clf
    polardb(T,Fdb,'k-')
    title(['Azimuth antenna pattern: SLL = ',num2str(SLLdb),', BLL = ',num2str(BLLdb)])
   end
end
 
% compute contours of Rmax by computing the SNR over a rectangular grid
% target range and angle change; jammer location fixed
   Rtmax=Rmaxkm*1e3;  % max/min target range
   dRt=Astep;
   x=[-Rtmax:dRt:Rtmax]; y=x;
   N=length(x);
% if gammag = 0 then use the closed form solution since only one contour exists
if gammag == 0
    msg = ['Computing contours (no multipath)'];         
    msgComputing(msg);
    pause(0.1);
    ic=0;
  for phi=Astart:Astep:Astop
   ic=ic+1;
     Ang(ic)=phi*rad; Xt=cos(phi*rad); Yt=sin(phi*rad);
       [thetaja,phija]=earth2ant(Xt,Yt,ht,xj,yj,hj,hr);
       Grj=antradpat(wave,Wa,We,SLLdb,BLLdb,thetaja,phija);
       Rslant=((Pt*G0^2*rcs*wave^2*Gp)/(4*pi)^3/SNRmin/...
          (Pj*Gj*Grj*(Bn/Bj)*(wave/4/pi/Rj)^2+No))^(1/4);
% take out radar/target heights from slant range to get ground range
       Rtgt(ic)=sqrt(Rslant^2-(ht-hr)^2);
  end
% delete msgComputing figure
delete(get(0,'CurrentFigure'));
RXmax=max(Rtgt);
Rkm0=(floor(RXmax/1e3/10)+1)*10;
  figure(3),clf
  % set a maximum detection range ring (ring spacing drng)
  polar(Ang,Rtgt/1e3,'k-'), hold on
  polar(Rkm0,0);
  text(0,0,'R') 
  text(xj/1000,yj/1000,'J')  % jammer range fixed -- label it
  title('Detection Contour (Ground Range, km)')
end   % end of gammag=0 test

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if gammag > 0
% if gammag > 0 use contours since multiple rings may exist
% two-dimensional matrices of range and angle
   X=ones(N,1)*x;
   Y=(ones(N,1)*y)';
   Phi=atan2(Y,X);
   Rho=sqrt(X.^2+Y.^2);
   msg = ['Computing contours using ',num2str(N^2),' grid points (multipath included)'];         
   msgComputing(msg);
   pause(0.1);

% compute signal power
for i=1:N
   for m=1:N
% target range and angle; jammer fixed
   	Rt=Rho(i,m); angt=Phi(i,m); 
      Xt=Rho(i,m)*cos(Phi(i,m)); 
      Yt=Rho(i,m)*sin(Phi(i,m));	
% radar antenna gain in the direction of the jammer 
% the main beam is assumed to be tracking the target if target is moving
       [thetaja,phija]=earth2ant(Xt,Yt,ht,xj,yj,hj,hr);
       Grj=antradpat(wave,Wa,We,SLLdb,BLLdb,thetaja,phija);       
% radar/target path-gain factor 
% assume the same gain for the direct and reflected paths
       if Rt <= 1e-4, Fr=NaN; end
       if Rt > 1e-4
           Fr=abs(1+gam*exp(-j*k*(2*hr*ht/Rt)));
	    end
% radar/jammer path-gain factor 
% assume the gain is the same for the direct and reflected paths
 		  Fj=abs(1+gam*exp(-j*k*(2*hr*hj/Rj)));
% target signal
        if Rt <= 1e-4, Pr=NaN; end
        if Rt > 1e-4
           Pr=Pt*G0^2*wave^2*rcs*Gp/(4*pi)^3/Rt^4*Fr^4;
        end
% jammer signal
		  Prj=Pj*Gj*wave^2*Grj*(Bn/Bj)/(4*pi*Rj)^2*Fj^4;
% signal to jammer plus noise ratio
	     SNR(i,m)=Pr/(Prj+No);
		 if Rho(i,m) > Rtmax, SNR(i,m)=NaN; end
	end
end
% delete msgComputing figure
  delete(get(0,'CurrentFigure'));
% plot contours of MDS
  Rkm0=Rtmax;  
figure(3),clf
polar(0,Rkm0/1000)
hold on
snrdb=10*log10(SNR+1e-20); 
contour(X/1000,Y/1000,snrdb,[SNRmindb,SNRmindb],'k-')
text(0,0,'R'), 
text(xj/1000,yj/1000,'J')  % jammer range fixed -- label it
title(['SNR Contour Level is ',num2str(SNRmindb),...
 ' dB                                                           Range in km'])
end  % end of gammag>0 test


  case 'Close'       
      h_figs = get(0,'children');    
      for fig = h_figs'              
            delete(fig);      
	   end             
                  
   case 'Print'
      h_figs = get(0,'children');
		for fig = h_figs'
         if strcmp(get(fig,'Tag'),'radjam')
            figure(fig);  
            print;
            break;
         end
      end   
 end   % end of switch











